package mpi.eudico.client.annotator.commands;

import mpi.eudico.client.annotator.gui.SegmentationDialog;

import mpi.eudico.server.corpora.clomimpl.abstr.TranscriptionImpl;


/**
 * Creates a segmentation dialog.
 *
 * @author Han Sloetjes
 */
public class SegmentationDlgCommand implements Command {
    private String commandName;

    /**
     * Creates a new SegmentationDlgCommand instance
     *
     * @param name the name of the command
     */
    public SegmentationDlgCommand(String name) {
        commandName = name;
    }

    /**
     * <b>Note: </b>it is assumed the types and order of the arguments are
     * correct.
     *
     * @param receiver the Transcription
     * @param arguments the arguments:
     */
    public void execute(Object receiver, Object[] arguments) {
        TranscriptionImpl transcription = (TranscriptionImpl) receiver;

        if (transcription != null) {
            new SegmentationDialog(transcription).setVisible(true);
        }
    }

    /**
     * Returns the name of the command.
     *
     * @return the name of the command
     */
    public String getName() {
        return commandName;
    }
}
