package mpi.eudico.client.annotator.commands;

import mpi.eudico.client.annotator.ElanLayoutManager;

/**
 * Switches to media synchronization mode.
 * 
 * @version 2 a switch to synchronisation mode is now allowed
 * even if there already are annotations.
 *
 * @author Han Sloetjes
 */
public class SyncModeCommand implements Command {
    private String commandName;

    /**
     * Creates a new SyncModeCommand instance
     *
     * @param name DOCUMENT ME!
     */
    public SyncModeCommand(String name) {
        commandName = name;
    }

    /**
     * 
     *
     * @param receiver the ElanLayoutManager
     * @param arguments the arguments:  <ul><li>arguments[0] = the
     *        Transcription (Transcription)</li> </ul>
     */
    public void execute(Object receiver, Object[] arguments) {
        ((ElanLayoutManager) receiver).showSyncMode();
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getName() {
        return commandName;
    }
}
