package mpi.eudico.client.annotator.recognizer.gui;

import java.util.ArrayList;
import java.util.HashMap;

import mpi.eudico.client.annotator.ViewerManager2;
import mpi.eudico.client.annotator.recognizer.api.AvailabilityDetector;
import mpi.eudico.client.annotator.recognizer.api.Recognizer;

public class VideoRecognizerPanel extends AbstractRecognizerPanel {

	public VideoRecognizerPanel(ViewerManager2 viewerManager,
			ArrayList<String> mediaFilePaths) {
		super(viewerManager, mediaFilePaths);
	}

	/**
	 * Sets the mode to video and calls the super implementation of initComponents.
	 */
	@Override
	protected void initComponents() {
		mode = Recognizer.VIDEO_TYPE;
		super.initComponents();
	}



	@Override
	protected HashMap<String, Recognizer> getAvailableRecognizers() {
		return AvailabilityDetector.getVideoRecognizers(mediaFilePaths);
	}
	
}
