package mpi.util.gui;

import java.io.IOException;
import java.net.URL;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

/**
 * Created on Apr 8, 2004
 * @author Alexander Klassmann
 * @version July, 2004
 */
public class SimpleHtmlViewer extends JDialog {

	public SimpleHtmlViewer(JFrame frame, String title, boolean modal, String urlString) {
		super(frame, title, modal);
		try {
			final URL url = SimpleHtmlViewer.class.getResource(urlString);
			final JEditorPane htmlPane = new JEditorPane(url);
			htmlPane.setEditable(false);
			JScrollPane scrollPane = new JScrollPane(htmlPane);
			getContentPane().add(scrollPane);

			htmlPane.addHyperlinkListener(new HyperlinkListener() {
				public void hyperlinkUpdate(HyperlinkEvent e) {
					if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
						//only care if link is to same document
						if (e.getURL().sameFile(url)) {
							try {
								htmlPane.scrollToReference(e.getURL().getRef());
							}
							catch (Throwable t) {
								t.printStackTrace();
							}
						}
				}
			});

		}
		catch (IOException e) {}
	}

}
